searchData={"items":[{"type":"module","title":"CsrfPlus","doc":"A CSRF (Cross-Site Request Forgery) protection Plug with accesses storing support.","ref":"CsrfPlus.html"},{"type":"function","title":"CsrfPlus.default_token_max_age/0","doc":"The default max age for a token","ref":"CsrfPlus.html#default_token_max_age/0"},{"type":"function","title":"CsrfPlus.get_user_info/1","doc":"Digs into the connection data to make an user access information struct.","ref":"CsrfPlus.html#get_user_info/1"},{"type":"function","title":"CsrfPlus.put_header_token/2","doc":"Put the token in the header. It uses the conn struct to determine the header name.","ref":"CsrfPlus.html#put_header_token/2"},{"type":"function","title":"Params - CsrfPlus.put_header_token/2","doc":"* `conn` - the connection struct.\n* `signed_token` - the signed version of the CSRF token.","ref":"CsrfPlus.html#put_header_token/2-params"},{"type":"function","title":"CsrfPlus.put_session_token/3","doc":"Put the token and the given `access_id` in the session. Uses the conn struct to\ndetermine the needed keys.","ref":"CsrfPlus.html#put_session_token/3"},{"type":"function","title":"Params - CsrfPlus.put_session_token/3","doc":"* `conn` - the connection struct.\n* `token` - the CSRF unsigned token.\n* `access_id` - the access id. If none is given no access id is put in the session. Defaults to nil.","ref":"CsrfPlus.html#put_session_token/3-params"},{"type":"function","title":"CsrfPlus.put_store_token/3","doc":"Put the token in the store. If a `conn_to_access` function is implemented in the\nconfigured store, that function will be called with the given params to generate\nthe `CsrfPlus.UserAccess` to be put into the store. Also, have a look at `CsrfPlus.Store.Behaviour`\nto see more about `conn_to_access` callback.","ref":"CsrfPlus.html#put_store_token/3"},{"type":"function","title":"Params - CsrfPlus.put_store_token/3","doc":"* `conn` - the connection struct.\n* `token` - the CSRF unsigned token.\n* `access_id` - the access id. It's required here because a token must be associeted with an identifier.","ref":"CsrfPlus.html#put_store_token/3-params"},{"type":"function","title":"CsrfPlus.put_token/2","doc":"Uses the plug configuration to put the token and its signed version\ninto the store, session and `x-csrf-token` header.\n\nThis function uses the functions: `put_session_token/3`, `put_header_token/2` and `put_store_token/3`\nbase functions under the hood. So, you can have a look at them for more information about how this function works.","ref":"CsrfPlus.html#put_token/2"},{"type":"function","title":"Params - CsrfPlus.put_token/2","doc":"* `conn` - The connection struct.\n  * `opts` - The options.\n\n#","ref":"CsrfPlus.html#put_token/2-params"},{"type":"function","title":"Options - CsrfPlus.put_token/2","doc":"The options is a Keyword with the follwing keys:\n\n  * `:access_id` - the id of the access. If none is given CsrfPlus will generate one.\n  * `:token_tuple` - a tuple with the token and its signed version in the format `{token, signed_token}`. This option is required.\n  * `:excludes` - a list of tokens to exclude. A excluded token will not\n  be put into its corresponding store, session or header.\n\n#","ref":"CsrfPlus.html#put_token/2-options"},{"type":"function","title":"Excludes list - CsrfPlus.put_token/2","doc":"* `:session` - do not put the session token.\n  * `:header` - do not put the header token.\n  * `:store` - do not put the store token.","ref":"CsrfPlus.html#put_token/2-excludes-list"},{"type":"behaviour","title":"CsrfPlus.ErrorMapper","doc":"Defines the behaviour for an ErrorModule while also defining a default map function.","ref":"CsrfPlus.ErrorMapper.html"},{"type":"function","title":"CsrfPlus.ErrorMapper.map/1","doc":"Maps a CsrfPlus exception into a tuple with the status code and the error map.","ref":"CsrfPlus.ErrorMapper.html#map/1"},{"type":"callback","title":"CsrfPlus.ErrorMapper.map/1","doc":"","ref":"CsrfPlus.ErrorMapper.html#c:map/1"},{"type":"function","title":"CsrfPlus.ErrorMapper.module_from_string/1","doc":"Converts back a string representation of a module to an actual module name","ref":"CsrfPlus.ErrorMapper.html#module_from_string/1"},{"type":"function","title":"CsrfPlus.ErrorMapper.module_to_string/1","doc":"Converts a module to string, but without the Elixir prefix.","ref":"CsrfPlus.ErrorMapper.html#module_to_string/1"},{"type":"behaviour","title":"CsrfPlus.Store.Behaviour","doc":"Defines the behaviour for a store.","ref":"CsrfPlus.Store.Behaviour.html"},{"type":"callback","title":"CsrfPlus.Store.Behaviour.all_accesses/0","doc":"Returns all the accesses in the store.","ref":"CsrfPlus.Store.Behaviour.html#c:all_accesses/0"},{"type":"callback","title":"CsrfPlus.Store.Behaviour.conn_to_access/2","doc":"A function to return the user access struct for a given connection and raw access map.","ref":"CsrfPlus.Store.Behaviour.html#c:conn_to_access/2"},{"type":"callback","title":"Params - CsrfPlus.Store.Behaviour.conn_to_access/2","doc":"* `conn` - The connection struct.\n* `raw_access` - A map with the required access information.\n\n#","ref":"CsrfPlus.Store.Behaviour.html#c:conn_to_access/2-params"},{"type":"callback","title":"Raw Access - CsrfPlus.Store.Behaviour.conn_to_access/2","doc":"* `:access_id` - The id that identifies the access.\n* `:token` - The access token.","ref":"CsrfPlus.Store.Behaviour.html#c:conn_to_access/2-raw-access"},{"type":"callback","title":"CsrfPlus.Store.Behaviour.delete_access/1","doc":"Deletes an access from the store by its `access_id`.\n\nReturns\n  * `{:ok, user_access}` if the access was successfully deleted. `user_access` is the access that was deleted.\n  * `{:error, reason}` if it was not possible for any `reason`.","ref":"CsrfPlus.Store.Behaviour.html#c:delete_access/1"},{"type":"callback","title":"CsrfPlus.Store.Behaviour.delete_dead_accesses/1","doc":"May delete all the tokens in the store that had expired. Other option, is to flag them as expired.\n\nReturns\n`:ok` in case of success or `{:error, reason}` otherwise.","ref":"CsrfPlus.Store.Behaviour.html#c:delete_dead_accesses/1"},{"type":"callback","title":"CsrfPlus.Store.Behaviour.get_access/1","doc":"Given an `access_id`, returns the access associated with it.","ref":"CsrfPlus.Store.Behaviour.html#c:get_access/1"},{"type":"callback","title":"CsrfPlus.Store.Behaviour.put_access/1","doc":"Puts an access in the store.\n\nReturns\n  * `{:ok, UserAccess.t()}` if the access was successfully store\n  * `{:error, reason}` if it was not possible for any `reason`.","ref":"CsrfPlus.Store.Behaviour.html#c:put_access/1"},{"type":"module","title":"CsrfPlus.Store.Manager","doc":"Manager to check the configured store tokens age.\nIf a token age is greater than the max age configured, the token is flagged as expired.\n\nThe manager is started by the `start_link/1` function.","ref":"CsrfPlus.Store.Manager.html"},{"type":"function","title":"CsrfPlus.Store.Manager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"CsrfPlus.Store.Manager.html#child_spec/1"},{"type":"function","title":"CsrfPlus.Store.Manager.start_link/1","doc":"Starts the Manager.\n\n  > ##","ref":"CsrfPlus.Store.Manager.html#start_link/1"},{"type":"function","title":"Note {: .info} - CsrfPlus.Store.Manager.start_link/1","doc":"> It's preferable to start this by the `CsrfPlus.Supervisor`.\n\n`init_arg` - Is a Keyword with the options to be used.","ref":"CsrfPlus.Store.Manager.html#start_link/1-note-info"},{"type":"function","title":"Options - CsrfPlus.Store.Manager.start_link/1","doc":"* `:token_max_age` - Maximum age of the tokens before they expires. It's a non-negative integer with the age in milliseconds. Defaults to one day.\n\n  * `:check_age_time` - How often to check the age of the tokens. Non-negative integer with the time in milliseconds. Defaults to one hour.","ref":"CsrfPlus.Store.Manager.html#start_link/1-options"},{"type":"module","title":"CsrfPlus.Store.MemoryDb","doc":"A Store to keep the `CsrfPlus.UserAccess` data in memory. The `CsrfPlus.UserAccess` is where the token and its expiration flag is set.","ref":"CsrfPlus.Store.MemoryDb.html"},{"type":"function","title":"CsrfPlus.Store.MemoryDb.all_accesses/0","doc":"Retrieve all the accesses in the memory","ref":"CsrfPlus.Store.MemoryDb.html#all_accesses/0"},{"type":"function","title":"CsrfPlus.Store.MemoryDb.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"CsrfPlus.Store.MemoryDb.html#child_spec/1"},{"type":"function","title":"CsrfPlus.Store.MemoryDb.delete_access/1","doc":"Deletes an access from the memory by its `access_id`","ref":"CsrfPlus.Store.MemoryDb.html#delete_access/1"},{"type":"function","title":"CsrfPlus.Store.MemoryDb.delete_dead_accesses/1","doc":"Actually, check the tokens age and flag all the ones that had expired.","ref":"CsrfPlus.Store.MemoryDb.html#delete_dead_accesses/1"},{"type":"function","title":"CsrfPlus.Store.MemoryDb.get_access/1","doc":"Retrieve an access from the memory by its `access_id`","ref":"CsrfPlus.Store.MemoryDb.html#get_access/1"},{"type":"function","title":"CsrfPlus.Store.MemoryDb.put_access/1","doc":"Put an access in the memory","ref":"CsrfPlus.Store.MemoryDb.html#put_access/1"},{"type":"function","title":"CsrfPlus.Store.MemoryDb.start_link/1","doc":"Starts the `CsrfPlus.Store.MemoryDb`.","ref":"CsrfPlus.Store.MemoryDb.html#start_link/1"},{"type":"module","title":"CsrfPlus.Supervisor","doc":"Supervisor to keep the `CsrfPlus.Store.Manager` running.\n\nIf `CsrfPlus.Store.MemoryDb` module is set as the store, then it will also be\nmanaged by this supervisor.","ref":"CsrfPlus.Supervisor.html"},{"type":"function","title":"CsrfPlus.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"CsrfPlus.Supervisor.html#child_spec/1"},{"type":"function","title":"CsrfPlus.Supervisor.start_link/1","doc":"Starts the supervisor.\n`init_arg` - The options to be used by `CsrfPlus.Store.Manager`.","ref":"CsrfPlus.Supervisor.html#start_link/1"},{"type":"behaviour","title":"CsrfPlus.Token","doc":"Defines the Token behaviour and a DefaultToken module implementation.","ref":"CsrfPlus.Token.html"},{"type":"function","title":"CsrfPlus.Token.generate/0","doc":"Calls the configured Token module to generate a token","ref":"CsrfPlus.Token.html#generate/0"},{"type":"callback","title":"CsrfPlus.Token.generate/0","doc":"The function to generate a token. It must returns a tuple with the token itself and the signed version of it.\nIn the format `{token, signed_token}`.\n\nThe `signed_token` is the token signed with some secret key or crypto algorithm that allows further verification.","ref":"CsrfPlus.Token.html#c:generate/0"},{"type":"function","title":"CsrfPlus.Token.verify/1","doc":"Calls the configured Token module to verify a `signed_token`","ref":"CsrfPlus.Token.html#verify/1"},{"type":"callback","title":"CsrfPlus.Token.verify/1","doc":"Simply put, must verifies a `signed_token`.\n\nReturns `{:ok, verified_token}` in case of success. Or `{:error, the_error_itself}`.\n\nThe `verified_token` is the original token before being signed.","ref":"CsrfPlus.Token.html#c:verify/1"},{"type":"module","title":"CsrfPlus.Token.DefaultToken","doc":"The default module implementation for the Token behaviour.\n\nIt uses the `Plug.Crypto.MessageVerifier` module to sign and verify tokens under the hood.","ref":"CsrfPlus.Token.DefaultToken.html"},{"type":"function","title":"CsrfPlus.Token.DefaultToken.generate/0","doc":"","ref":"CsrfPlus.Token.DefaultToken.html#generate/0"},{"type":"function","title":"CsrfPlus.Token.DefaultToken.verify/1","doc":"","ref":"CsrfPlus.Token.DefaultToken.html#verify/1"},{"type":"module","title":"CsrfPlus.UserAccess","doc":"Represents an user access. This struct is where you can set a token and other user access related informations.","ref":"CsrfPlus.UserAccess.html"},{"type":"type","title":"CsrfPlus.UserAccess.t/0","doc":"The UserAccess type:\n\n  * `:token` - The token of the access.\n  * `:access_id` - A unique id to identify the access.\n  * `:expired?` - A flag indicating if the access is expired or not.\n  * `:user_info` - The user access information. See more at `CsrfPlus.UserAccessInfo`.\n  * `:created_at` - The time stamp in milliseconds of the access creation.","ref":"CsrfPlus.UserAccess.html#t:t/0"},{"type":"module","title":"CsrfPlus.UserAccessInfo","doc":"Defines a basic user access information containing the ip and the user agent.","ref":"CsrfPlus.UserAccessInfo.html"},{"type":"function","title":"CsrfPlus.UserAccessInfo.user_info_from_map/1","doc":"Will convert a raw map with `:ip` and `:user_agent` into a `CsrfPlus.UserAccessInfo` struct.","ref":"CsrfPlus.UserAccessInfo.html#user_info_from_map/1"},{"type":"function","title":"CsrfPlus.UserAccessInfo.user_info_from_string/1","doc":"Converts a JSON object string with `:ip` and `:user_agent` fields into a `CsrfPlus.UserAccessInfo` struct.","ref":"CsrfPlus.UserAccessInfo.html#user_info_from_string/1"},{"type":"function","title":"CsrfPlus.UserAccessInfo.user_info_to_string/1","doc":"Converts a `CsrfPlus.UserAccessInfo` struct into a JSON object string.","ref":"CsrfPlus.UserAccessInfo.html#user_info_to_string/1"},{"type":"type","title":"CsrfPlus.UserAccessInfo.t/0","doc":"The User access information.\n\n  * `:ip` - The most trustable IP address you can get.\n  * `:user_agent` - The user agent string of the requests.","ref":"CsrfPlus.UserAccessInfo.html#t:t/0"},{"type":"exception","title":"CsrfPlus.Exception","doc":"CsrfPlus exceptions.","ref":"CsrfPlus.Exception.html"},{"type":"function","title":"CsrfPlus.Exception.csrf_plus_exception?/1","doc":"Checks if the given exception is a CsrfPlus exception.\nReturns a boolean true if the given exception is a CsrfPlus.","ref":"CsrfPlus.Exception.html#csrf_plus_exception?/1"},{"type":"function","title":"CsrfPlus.Exception.exception/1","doc":"Creates a new CsrfPlus exception based on the given params during the `Kernel.raise/2` call.\n\nPassing no param will create a `CsrfPlus.Exception`.\n\nIf a string is passed it will be used as the exception message.\n\nIf it's an exception module name (an atom) an exception will be created from it with the default message set in the\n`exceptions/0` function.\n\nWhen a tuple is passed in the format `{which, type}` an exception with name `which` will be created having the message set in the\n`exception/1` function with the message in `type`.","ref":"CsrfPlus.Exception.html#exception/1"},{"type":"function","title":"Examples - CsrfPlus.Exception.exception/1","doc":"iex> raise CsrfPlus.Exception\n     ** (CsrfPlus.Exception) invalid token\n\n     iex> raise CsrfPlus.Exception, \"custom message\"\n     ** (CsrfPlus.Exception) custom message\n\n     iex> raise CsrfPlus.Exception, CsrfPlus.Exception.StoreException\n     ** (CsrfPlus.Exception.StoreException) no store is set\n\n     iex> raise CsrfPlus.Exception, {CsrfPlus.Exception.StoreException, :token_not_found}\n     ** (CsrfPlus.Exception.StoreException) token was not found","ref":"CsrfPlus.Exception.html#exception/1-examples"},{"type":"function","title":"CsrfPlus.Exception.exceptions/0","doc":"Retrieve all the CsrfPlus exceptions with their corresponding names and messages","ref":"CsrfPlus.Exception.html#exceptions/0"},{"type":"exception","title":"CsrfPlus.Exception.HeaderException","doc":"","ref":"CsrfPlus.Exception.HeaderException.html"},{"type":"exception","title":"CsrfPlus.Exception.MismatchException","doc":"","ref":"CsrfPlus.Exception.MismatchException.html"},{"type":"exception","title":"CsrfPlus.Exception.SessionException","doc":"","ref":"CsrfPlus.Exception.SessionException.html"},{"type":"exception","title":"CsrfPlus.Exception.StoreException","doc":"","ref":"CsrfPlus.Exception.StoreException.html"},{"type":"extras","title":"CsrfPlus","doc":"# CsrfPlus\nA plug-based CSRF (Cross-Site Request Forgery) protection library with accesses storing support.\n\nSometimes, you need more than a per-request CSRF tokens. This is why this Plug was created.\nThis plug supports storing tokens in any kind of storage system. And all you have to do is to\nimplement its `CsrfPlus.Store.Behaviour`. By doing so you will provide ways to put, get,\ndelete and other operations of accesses on that 'Store'.","ref":"readme.html"},{"type":"extras","title":"How it works? - CsrfPlus","doc":"When a request is made, this plug will check the request method type. Request methods intended\nfor reading data (GET, HEAD, OPTIONS) will be ignored, by default. The other requests will be\nchecked against the CSRF token stored in the connection session, in the `x-csrf-token` header\nand the one stored in the configured Store. All those tokens must match to each other to be\nconsidered valid. The first checkings are to ensure the tokens are given. Then, the token in\nthe session and the one in the Store are verified against each other. Later, the token on the\n`x-csrf-token` header that is a signed version of the generated token with the configured secret\nkey will be verified against that secret key. If this verification succeeds, the returned verified\ntoken will be checked against the token in the store. If this verification also succeeds, the\nconnection continues normally. Otherwise, if any of the checks fails, an exception will be raised\nand used to build the error message and response status code.","ref":"readme.html#how-it-works"},{"type":"extras","title":"Usage - CsrfPlus","doc":"You can use CsrfPlus as a plug in your endpoint, router or in some plug pipeline. As this plug\nuses connection session, it must be plugged after `Plug.Session` and `Plug.Conn.fetch_session/2`.\nAlso, this plug won't check requests origin. So, to have safer connections, use some CORS lib of\nyour choice before CsrfPlus. A good choice is the [Corsica](https://github.com/whatyouhide/corsica) project.\n\nOne of the princeples of this plug is to avoid the most to do \"dark magic\". As so, you must generate the token and its signed version,\nprovide an `:access_id` and normal token in the user session and, store both the token and the `access_id` in the\nconfigured store and, finally, include the signed token in the `x-csrf-token` header. Usually, you do this step in\nresponse to a GET method request, thinking of a JSON API. But you can also use this plug with heex template\npages/components. Examples on that will be released soon.\n\nAnyway, we provide a helper function to get the tokens ready to be send in the response connection and stored\nin the configured store. This function is `CsrfPlus.put_token/2`. You will still need to generate, at least,\nthe token and its signed version.\n\nWhen using CORS, remmember to add the `x-csrf-token` header to the allowed and exposed headers. Also enable/allow the\nsession credentials.\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"The access - CsrfPlus","doc":"Tokens are stored as accesses and each access must have a unique id, the `access_id`. You can use `UUID.uuid4/0`\nto generate a unique id.\nThis `access_id` must be the same as the token in the session and the one in the store. This is because CsrfPlus\nwill, when checking a request, retrieve the `access_id` from the session and then use it to load the token in the\nstore. A found token with the given access id will be used later to test the tokens from session and `x-csrf-token`\nin the header.","ref":"readme.html#the-access"},{"type":"extras","title":"How to install? - CsrfPlus","doc":"Simply, add `:csrf_plus` to you mix dependencies:\n\n```elixir\n# mix.exs\ndef deps do\n  [\n    {:plug, \"~> 1.0\"},\n    {:csrf_plus, \"~> 0.1\"}\n  ]\n```\n\nAnd then run `$ mix deps.get`.","ref":"readme.html#how-to-install"},{"type":"extras","title":"Setting it up - CsrfPlus","doc":"#","ref":"readme.html#setting-it-up"},{"type":"extras","title":"Configs - CsrfPlus","doc":"`CsrfPlus` uses some configurations to get ready to run.\n\n##","ref":"readme.html#configs"},{"type":"extras","title":"Token module - CsrfPlus","doc":"This module is responsible to generate and verify tokens.\nYou can create your own Token module, since you implement the `CsrfPlus.Token` behaviour.\n\nThis lib ships with a 'DefaultToken' module, that is used for that. But if you\nwant to set a custom Token module, use the config:\n\n```elixir\n# config/config.exs\nconfig :csrf_plus, CsrfPlus.Token, token_mod: YourTokenModule\n```\n\nWhen using the 'DefaultToken', you can define the function to be used to generate tokens\nor use the default one.\nTo config the token generator function add the following to your config:\n\n```elixir\n# config/config.exs\nconfig :csrf_plus, CsrfPlus.Token, token_generation_fn: &your_function/0\n```\n\nSuch a function must return a string (binary) that is the token itself. That\ntoken must be unique.\n\nFinally, if you want to use the 'DefaultToken' module, you should set the\n`:secret_key` to be used to generate and verify tokens. That key must be at least 64\nbytes long.\n\nConfig with:\n\n```elixir\n# config/config.exs\nconfig :csrf_plus, CsrfPlus.Token, secret_key: \"a_good_strong_random_secret\"\n```\n\n> ##","ref":"readme.html#token-module"},{"type":"extras","title":"Please note {: .info} - CsrfPlus","doc":"> This `:secret_key` is only needed if you are using the 'DefaultToken'\n> module.\n\n##","ref":"readme.html#please-note-info"},{"type":"extras","title":"Store module - CsrfPlus","doc":"In short, the store module is the module that implements the Store behaviour\nand will keep your generated tokens ready to be checked against. If any served\ntoken is not on the store, it is considered as invalid. For more information about\nStores look at the `CsrfPlu.Store.Behaviour` module.\nTo config the used store module, add the following:\n\n```elixir\n# config/config.exs\nconfig :csrf_plus, CsrfPlus, store: YourStoreModule\n```\n\nThere is no store set by default. But if you don't care about that, you can use\nthe builtin `CsrfPlus.Store.MemoryDb` store. As it names suggests, it will store\ntokens (accesses, actually) in memory, using a `GenServer`.\n\nIf so, do:\n\n```elixir\n# config/config.exs\nconfig :csrf_plus, CsrfPlus, store: CsrfPlus.Store.MemoryDb \n```\n\n#","ref":"readme.html#store-module"},{"type":"extras","title":"Options - CsrfPlus","doc":"The `CsrfPlus` plug accepts some options at its initialization.\nThe following options are available:\n\n  * `:csrf_key` - The key under the token is stored in the connection session. Defaults to: `\"_csrf_key_\"`\n\n  * `:allowed_methods` - The requests methods that are ignored by the CSRF token validations.\nBy defaut: `[\"GET\", \"HEAD\", \"OPTIONS\"]`.\n\n  * `:error_mapper` - The module to be used to map exceptions to response status codes and error messages.\nThere is a default module for that: `CsrfPlus.ErrorMapper`. But you can set your own module\nsince it implements the `CsrfPlus.ErrorMapper` behaviour.\n\n#","ref":"readme.html#options"},{"type":"extras","title":"Supervisor - CsrfPlus","doc":"As the CSRF validation of this lib uses a store of tokens, it's a good practice to\nlet them have a life span. And to keep the Store of tokens updated by this rule, we\nuse a store manager `CsrfPlus.Store.Manager` that will check all the tokens in the store\nand flag the expired tokens as so. That Manager can be started directly, but to make it\neasier to use with the default `CsrfPlus.Store.MemoryDb` store, we provide a `CsrfPlus.Supervisor` that\nwill not only start them, but also keep them up.\n\nTo start the Supervisor include the following entry in your application start function:\n\n```elixir\n# application.ex\ndef start(_type, _args) do\n  #...\n\n  children = [\n    #...\n    {CsrfPlus.Supervisor, opts}\n    #...\n  ]\n\n  #...\nend\n```\n\nReplace opts by the options you want to set for the `CsrfPlus.Store.Manager`.\nFor more information about the options look at the module documentation.","ref":"readme.html#supervisor"}],"content_type":"text/markdown"}